from calculate.vars.datavars import Variable, Namespace, HashVariable, TableVariable


class Linux(Namespace):
    class Shortname(Variable):
        value = ""

    class Ver(Variable):
        value = ""

    class Fullname(Variable):
        value = ""

    class Subname(Variable):
        value = ""

    class Arch(Variable):
        value = ""

    class Test(Variable):
        value = ""

    class Title(Variable):
        def get(self):
            subname = self.vars.subname.getValue(self)
            fullname = self.vars.fullname.getValue(self)
            ver = self.vars.ver.getValue(self)
            if subname:
                return "%s %s %s" % (fullname, subname, ver)
            else:
                return "%s %s" % (fullname, ver)

class Hashvar(HashVariable):
    class Data(HashVariable.Data):
        def get(self):
            return {
                'value1': 'test1',
                'value2': 'test2',
            }

    class Calculate(Variable):
        def get(self):
            return "%s %s" % (
                self.vars.value1.getValue(self),
                self.vars.value2.getValue(self)
            )

    hash_vars = ["value1", "value2"]
        
class Tablevar(TableVariable):
    class Data(TableVariable.Data):
        def get(self):
            return [
                {
                    "dev": "/dev/sdb1",
                    "mount": "/",
                },
                {
                    "dev": "/dev/sdb2",
                    "mount": "/var/calculate",
                }
            ]
    hash_vars = ["dev", "mount"]
